-- usage: sudo -u postgres psql -d template1 -f setup-gnumed-roles.sql

-- user roles
create role "gm-dbo" with
	createdb
	createrole
	nocreateuser
	inherit
	login
	password 'gm-dbo'
;

create role "any-doc" with
	nocreatedb
	nocreaterole
	nocreateuser
	inherit
	login
	password 'any-doc'
;

-- group roles
create role "gnumed_v8" with
	nocreatedb
	nocreaterole
	nocreateuser
	inherit
	nologin
;

create role "gm-logins" with
	nocreatedb
	nocreaterole
	nocreateuser
	inherit
	nologin
;

create role "gm-public" with
	nocreatedb
	nocreaterole
	nocreateuser
	inherit
	nologin
;

create role "gm-doctors" with
	nocreatedb
	nocreaterole
	nocreateuser
	inherit
	nologin
;

-- define role membership and, thereby, access rights
grant "gnumed_v8" to "postgres";
grant "gm-logins" to "postgres";

grant "gnumed_v8" to "gm-dbo";
grant "gm-logins" to "gm-dbo";
grant "gm-public" to "gm-dbo";
grant "gm-doctors" to "gm-dbo";

grant "gnumed_v8" to "any-doc";
grant "gm-logins" to "any-doc";
grant "gm-public" to "any-doc";
grant "gm-doctors" to "any-doc";
